// score:100
// alternative dp solution, unfortunalely with a large constant, so it needs some pruning.
// uses the fact that we can start with greedy and then process As and Bs separately.
// for each of those, we can do a dp after soring
// dp [delta_A][delta_B] -> minimal index of last used mouse
// this dp is very tricky to implement
// O(n + A B^2)
#include <bits/stdc++.h>
using namespace std;

constexpr int inf = 1e9;

template<bool enabled>
struct Debug{
    template<typename S, typename T = void> struct Tag_Printable : false_type {};
    template<typename S> struct Tag_Printable<S, decltype((void)(cerr << declval<S>()))> : true_type {};
    template<typename S, typename T = void> struct Tag_Iterable: false_type {};
    template<typename S> struct Tag_Iterable<S, decltype((void)(begin(declval<S>()), end(declval<S>())))> : true_type {};
    template<typename T, typename... Args>
    Debug& print(T const&x, true_type, Args...){
        #ifdef LOCAL_RUN
        if(enabled){
            cerr << boolalpha << x;
        }
        #endif // LOCAL_RUN
        return *this;
    }
    template<typename T>
    Debug& print(T const&x, false_type, true_type){
        *this << "[";
        bool first = true;
        for(auto &e:x){
            if(!first) *this << ", ";
            *this << e;
            first = false;
        }
        return *this << "]";
    }
    template<typename S, typename T>
    Debug& print(pair<S, T> const&x, false_type, false_type){
        return *this << "(" << x.first << ", " << x.second << ")";
    }
    template<typename T>
    Debug& operator<<(T const&x){
        return print(x, Tag_Printable<T>{}, Tag_Iterable<T>{});
    }
};
 Debug<true> debug;
// Debug<false> debug; // disable debug printing
#define named(x) string(#x) << " : " <<  x


template<typename T>
pair<T, T>& operator+=(pair<T, T> &a, pair<T, T> const&b){
    a.first += b.first;
    a.second += b.second;
    return a;
}
template<typename T>
pair<T, T> operator+(pair<T, T> a, pair<T, T> const&b){
    a+=b;
    return a;
}
int64_t cdiv(int64_t a, int64_t b){
    assert(0 < b);
    if(a > 0) return (a + b-1)/b;
    return a/b;
}
int ccdiv(int a, int b){
    assert(0 < b);
    if(a > 0) return (a + b-1)/b;
    return a/b;
}
template<typename T>
bool xmin(T&a, T const&b){
    if(b < a){
        a = b;
        return true;
    } else {
        return false;
    }
};
template<typename T>
bool xmax(T&a, T const&b){
    if(b > a){
        a = b;
        return true;
    } else {
        return false;
    }
};

struct Decomp{
    Decomp(int A_, int B_) : A(A_), B(B_), U(2*A*B+1), pre(U, {-1, -1}), up(U){
        for(int i=0; i <= min(B-1, U/A); ++i){
            for(int j=0; j <= U/B; ++j){
                const int r = i*A + j*B;
                if(r < U){
                    pre[r] = make_pair(i, j);
                }
            }
        }
        assert(pre[U-1].first != -1);
        for(int i=U-1; i>=0; --i){
            if(pre[i].first == -1) up[i] = up[i+1];
            else up[i] = i;
        }
    }
    pair<int, int> operator()(int x) const {
        if(x >= 2*A*B){
            int a = max(0, x / (A*B)-1);
            return operator()(x - a*A*B) + make_pair(0, a*A);
        }
        auto ret = pre[up[x]];
        assert(ret.first != -1);
        return ret;
    }
    int A, B, U;
    vector<pair<int, int> > pre;
    vector<int> up;
};

// TODO: take care of non-comprime case -> zero cost improvements
vector<int> calc(int A, int B, vector<int> cnt){
    //debug << " ||| " << A << " " << B << "\n";
    //debug << named(cnt) << "\n";
    const int C = cnt.size();
    vector<int> cnt_pre(C+1);
    for(int i=0; i<C;++i){
        cnt_pre[i+1] = cnt_pre[i] + cnt[i];
    }
    // dp[As saved][Bs used] -> maximum last used index
    vector<vector<int> > dp(3*B, vector<int>(3*A, -1));
    dp[0][0] = cnt_pre.back();
    vector<pair<int, int> > states;
    for(int i=0; i<2*B; ++i){
        for(int j = (i*A+B-1)/B; j < 2*A; ++j){
            //if(j*B - i*A < A*B) // correct
            if(j*B - i*A < 4+A*B/6) // heuristic, seems to work fine
                states.emplace_back(i, j);
        }
    }
    sort(states.begin(), states.end(), [&](auto const&x, auto const&y){
        return make_pair(x.first*A-x.second*B, (x.first+x.second)) > make_pair(y.first*A-y.second*B, (y.first+y.second));
    });
    for(int x = C-1; x > 0; --x){
        const int y = cdiv(x*A, B);
        if(x == B) continue; // replacement of whole pizzas -> can be ignored
        const int PRE = cnt_pre[x];
        if(x*A == y*B){ // non-coprime step, very tricky
            // assert(__gcd(A, B) != 1);
            for(int i=0; i<2*B; ++i){
                const int j_base = (i*A+B-1)/B;
                const int j_max = min(2*A, j_base+A);
                for(int j=j_base; j<j_max; ++j){
                    if(dp[i][j] > PRE) xmax(dp[i+x][j+y], dp[i][j]-1);
                }
            }
            for(int i=0; i<2*B; ++i){
                const int j_base = (i*A+B-1)/B;
                const int j_max = min(2*A, j_base+A);
                for(int j=j_base; j<j_max; ++j){
                    xmax(dp[i][j], dp[i+B][j+A]);
                }
            }
            for(int i=0; i<2*B; ++i){
                const int j_base = (i*A+B-1)/B;
                const int j_max = min(2*A, j_base+A);
                for(int j=j_base; j<j_max; ++j){
                    if(dp[i][j] > PRE) xmax(dp[i+x][j+y], dp[i][j]-1);
                }
            }
        } else {
            // knapsack with items (x,y) and (-A,-B)
            // the order of computation is very tricky
            for(auto [i,j] : states){
                const int v = max(dp[i][j], dp[i+B][j+A]);
                dp[i][j] = v;
                if(v > PRE){
                    xmax(dp[i+x][j+y], v-1);
                }
            }
        }
        //if(PRE != cnt_pre.back()) debug << x << " " << y << " " << PRE << ":\n" << dp << "\n";
    }
    vector<int> ret(2*B);
    for(int i=0; i<2*B; ++i){
        //debug << i << " : " << dp[i] << " | ";
        int j = 0;
        while(j < 2*A && dp[i][j] == -1) ++j;
        ret[i] = j;
        //debug << j << "\n";
    }
    return ret;
}

void solve(){
    // start with greed
    int n, A, B;
    cin >> n >> A >> B;
    Decomp de(A, B);
    vector<int> v(n);
    int64_t add = 0;
    for(auto &e:v) {
        cin >> e;
        if(e > 2*A*B){
            int x = e/(A*B)-1;
            e -= x*A*B;
            add += x;
        }
    }
    vector<int> cnt_a(B+1), cnt_b(A+1);
    pair<int64_t, int64_t> cnt;
    for(auto const&e:v){
        auto tmp = de(e);
        ++cnt_a[min(B, tmp.first)];
        ++cnt_b[min(A, tmp.second)];
        cnt += decltype(cnt)(tmp.first, tmp.second);
    }
    int64_t ans = cdiv(cnt.first, B) + cdiv(cnt.second, A);
    // do improvement dp
    auto imp_a = calc(A, B, cnt_a);
    auto imp_b = calc(B, A, cnt_b);
    for(int i=0; i<2*B; ++i){
        for(int j=0; j<2*A; ++j){
            xmin(ans, cdiv(cnt.first-i+imp_b[j], B)+cdiv(cnt.second-j+imp_a[i], A));
        }
    }
    cout << add+ans << "\n";
}

signed main(){
    #ifdef LOCAL_RUN
    //freopen("in.txt", "r", stdin);
    #endif // LOCAL_RUN
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    cin.exceptions(ios::badbit | ios::eofbit | ios::failbit);
    int T = 1;
    // cin >> T;
    for(int it=0; it<T; ++it){
        solve();
    }
}
