// score:100
// very very fast dp solution
// ported to java
// O(n + A B^2)
import java.io.*;
import java.util.*;
import java.lang.*;


class Max{
    Max(int U_){
        U=U_; top=0;
        cnt = new int[2*U+1];
        cnt[0] = 1;
    }
    void up(int x, int v){
        x+=U;
        cnt[x] += v;
        if(v > 0){
            if(x > top) top = x;
            else if(cnt[top] == 0) {
                // only do this if v > 0, as we might do a v=-1
                // and then a v=+1, in which case we should not move top.
                while(cnt[top] == 0) --top;
            }
        }
    }
    int get(){
        return top - U;
    }
    int U;
    int top;
    int[] cnt;  
};
class Decomp{
    Decomp(int A_, int B_){
        A = A_; B = B_; U=2*A*B+1;
        pre = new int[U][2];
        for(int i=0; i<U; ++i) {
            for(int j=0; j<2; ++j) pre[i][j] = -1;
        }
        up = new int[U];
        for(int i=0; i <= Math.min(B-1, U/A); ++i){
            for(int j=0; j <= U/B; ++j){
                int r = i*A + j*B;
                if(r < U){
                    pre[r][0] = i;
                    pre[r][1] = j;
                }
            }
        }
        for(int i=U-1; i>=0; --i){
            if(pre[i][0] == -1) up[i] = up[i+1];
            else up[i] = i;
        }
    }
    int[] operator(int x)  {
        if(x >= 2*A*B){
            int a = Math.max(0, x / (A*B)-1);
            int[] tmp = operator(x - a*A*B);
            tmp[1] += a*A;
            return tmp;
        }
        int[] ret = new int[2];
        for(int i=0; i<2; ++i){
            ret[i] = pre[up[x]][i];
        }
        return ret;
    }
    int A, B, U;
    int[][] pre;
    int[] up;
};


class Task {
    long cdiv(long a, long b){
        if(a > 0) return (a + b-1)/b;
        return a/b;
    }
    void do_from (int i, int x){
        for(int j=0; j<i; ++j){
            // to avoid getting the same improvement twice,
            // we go from previous to next dp.
            change[j-i+B].up(dp2[j]-dp[i]-A, x);
        }
        for(int j=i+1; j<B; ++j){
            change[j-i].up(dp2[j]-dp[i], x);
        }
    }
    void do_to (int i, int x){
        for(int j=0; j<i; ++j){
            change[i-j].up(dp2[i]-dp[j], x);
        }
        for(int j=i+1; j<B; ++j){
            change[i-j+B].up(dp2[i]-dp[j]-A, x);
        }
    }
    public void solve(InputReader in, PrintWriter out) {
        int n = in.nextInt();
        A = in.nextInt();
        B = in.nextInt();
        Decomp de = new Decomp(A, B);
        int[] cnts = new int[2*A*B];
        long add = 0;
        for(int i=0; i<n; ++i){
            int e = in.nextInt();
            if(e >= 2*A*B){
                int x = e / (A*B) - 1;
            e -= x*A*B;
            add += x;
            }
            ++cnts[e];
        }
        int v_size = 0;
        for(int i=0; i<2*A*B; ++i){
            if(cnts[i] != 0) ++v_size;
        }
        int[][] v = new int[2][v_size];
        int jj = 0;
        for(int i=0; i<2*A*B; ++i){
            if(cnts[i] != 0){
                v[0][jj] = i;
                v[1][jj] = cnts[i];
                ++jj;
            }
        }
        long[] cnt = new long[2];
        for(int i=0; i<v_size; ++i){
            int[] tmp = de.operator(v[0][i]);
            for(int j=0; j<2; ++j){
                cnt[j] += v[1][i]*(long)tmp[j];
            }
        }
        long ans = cdiv(cnt[0], B) + cdiv(cnt[1], A);
        dp = new int[B];
        dp2 = new int[B];
        change = new Max[B];
        for(int i=0; i<B; ++i) change[i] = new Max(2*A);
        for(int i=0; i<B; ++i){
            do_to(i, 1);
        }
        int[] precalc = new int[2*A*B+1];
        for(int i=0; i<2*A; ++i){
            for(int j=1; j<=B; ++j){
                precalc[i*B+j] = i+1;
            }
        }
        for(int it2=0; it2<v_size; ++it2){
            int e = v[0][it2];
            int c = v[1][it2];
            for(int it=0; it<c; ++it){
                int did = 0;
                int[] start = de.operator(e);
                int LIM = Math.min(B-1, e/A+1);
                for(int a=0; a<=LIM; ++a){
                    int b = precalc[Math.max(0, e-a*A)];
                    int da = a - start[0];
                    int db = b - start[1];
                    if(da < 0){
                        da += B;
                        db -= A;
                    }
                    if(db < change[da].get()){
                        did = 1;
                        for(int i=0; i<B-da; ++i){
                            int j = i+da;
                            if(dp2[j] > dp[i] + db){
                                do_to(j, -1);
                                dp2[j] = dp[i] + db;
                                do_to(j, 1);
                            }
                        }
                        for(int i=B-da; i<B; ++i){
                            int j = i+da-B;
                            if(dp2[j] > dp[i] + db + A){
                                do_to(j, -1);
                                dp2[j] = dp[i] + db + A;
                                do_to(j, 1);
                            }
                        }
                    }
                }
                for(int i=0; i<B; ++i){
                    if(dp2[i] < dp[i]){
                        do_from(i, -1);
                        dp[i] = dp2[i];
                        do_from(i, 1);
                    }
                }
                if(did == 0) break;
            }
        }
        
        for(int i=0; i<B; ++i){
            ans = Math.min(ans, cdiv(cnt[0]+i, B)+cdiv(cnt[1]+dp[i], A));
        }
        out.println(add+ans);
    }
    int n, A, B;
    Max[] change;
    int[] dp, dp2;
}

class InputReader {
    public BufferedReader reader;
    public StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream), 32768);
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

    public long nextLong() {
        return Long.parseLong(next());
    }
}

public class submission {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        Task solver = new Task();
        solver.solve(in, out);
        out.close();
    }
}
