// score: 50
#include <cassert>
#include <cstdio>
#include <deque>
#include <vector>

int n, m, k, q;
std::vector<std::vector<int> > state;
std::vector<std::vector<int> > priv;

std::vector<std::vector<int> > d;

void read_edges(int m, std::vector<std::vector<int> > &edges) {
    for (int i = 0; i < m; i++) {
        int u, v;
        scanf("%d%d", &u, &v);
        edges[u].push_back(v);
        edges[v].push_back(u);
    }
}

void run_bfs(int cur, std::vector<int> &dist, std::deque<int> &deq,
    const std::vector<std::vector<int> > &nex, int d) {
    for (unsigned j = 0; j < nex[cur].size(); j++) {
        int s = nex[cur][j];
        if (dist[s] == -1) {
            dist[s] = dist[cur] + d;
            if (d == 0) deq.push_back(s);
            else deq.push_front(s);
        }
    }
}

void bfs(int from) {
    std::vector<int> dist(n, -1);
    dist[from] = 0;
    std::deque<int> deq;
    deq.push_front(from);
    while (!deq.empty()) {
        int cur = deq.back();
        deq.pop_back();
        run_bfs(cur, dist, deq, state, 0);
        run_bfs(cur, dist, deq, priv, 1);
    }
    d[from] = dist;
}

int main() {
    scanf("%d%d%d%d", &n, &m, &k, &q);
    state.resize(n);
    read_edges(m, state);
    priv.resize(n);
    read_edges(k, priv);

    d.resize(n);
    for (int i = 0; i < n; i++) bfs(i);

    for (int i = 0; i < q; i++) {
        int u, v;
        scanf("%d%d", &u, &v);
        printf("%d\n", d[u][v]);
    }

    return 0;
}
