# score: 100
import sys
import heapq

N, M, K, Q = list(map(int, sys.stdin.readline().split()))

union = []
for i in range(N):
    union.append(i)

def unionFind(i):
    if union[i] == i:
        return i
    union[i] = unionFind(union[i])
    return union[i]

for i in range(M):
    a, b = list(map(int, sys.stdin.readline().split()))
    union[unionFind(a)] = unionFind(b)

adj = []
for i in range(N):
    adj.append([])

for i in range(K):
    a, b = list(map(int, sys.stdin.readline().split()))
    a = unionFind(a)
    b = unionFind(b)
    if a != b:
        adj[a].append(b)
        adj[b].append(a)

dist = []
inf = 10**6
for i in range(N):
    disti = []
    dist.append(disti)
    if i == unionFind(i):
        for j in range(N):
            disti.append(inf)
        pq = [(0, i)]
        while len(pq) != 0:
            d, x = heapq.heappop(pq)
            if disti[x] != inf:
                continue
            disti[x] = d
            for o in adj[x]:
                heapq.heappush(pq, (d + 1, o))

for i in range(Q):
    a, b = list(map(int, sys.stdin.readline().split()))
    a = unionFind(a)
    b = unionFind(b)
    print(str(dist[a][b]))
