#include <bits/stdc++.h>
using namespace std;

const int INF = 1e9;

vector<int> dijkstra(vector<vector<pair<int, int>>> const& g, int start) {
  vector<int> dist(g.size(), INF);
  priority_queue<pair<int, int>, vector<pair<int, int>>, greater<>> pq;
  pq.emplace(0, start);
  while (!pq.empty()) {
    auto [cost, v] = pq.top();
    pq.pop();
    if (dist[v] != INF) continue;
    dist[v] = cost;
    for (auto [u, c] : g[v])
      pq.emplace(cost+c, u);
  }
  return dist;
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);

  int n, m, k, q;
  cin >> n >> m >> k >> q;

  vector<vector<pair<int, int>>> g(n);
  for (int i=0; i<m; ++i) {
    int a, b; cin >> a >> b;
    g[a].emplace_back(b, 0);
    g[b].emplace_back(a, 0);
  }
  for (int i=0; i<k; ++i) {
    int a, b; cin >> a >> b;
    g[a].emplace_back(b, 1);
    g[b].emplace_back(a, 1);
  }
  vector<vector<int>> dist(n);
  for (int s=0; s<n; ++s)
    dist[s] = dijkstra(g, s);
  for (int i=0; i<q; ++i) {
    int a, b; cin >> a >> b;
    cout << (dist[a][b] == INF ? -1 : dist[a][b]) << '\n';
  }
}
